'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});
var length = {
    'in': 96,
    'px': 1,
    'pt': 4 / 3,
    'pc': 16
};

var time = {
    's': 1000,
    'ms': 1
};

function dropLeadingZero(number) {
    var value = String(number);

    if (number % 1) {
        if (value[0] === '0') {
            return value.slice(1);
        }

        if (value[0] === '-' && value[1] === '0') {
            return '-' + value.slice(2);
        }
    }

    return value;
}

function transform(number, unit, conversion) {
    var one = undefined,
        base = undefined;
    var convertionUnits = Object.keys(conversion).filter(function (u) {
        if (conversion[u] === 1) {
            one = u;
        }
        return unit !== u;
    });

    if (unit === one) {
        base = number / conversion[unit];
    } else {
        base = number * conversion[unit];
    }

    return convertionUnits.map(function (u) {
        return dropLeadingZero(base / conversion[u]) + u;
    }).reduce(function (a, b) {
        return a.length < b.length ? a : b;
    });
}

exports['default'] = function (number, unit, _ref) {
    var convertTime = _ref.convertTime;
    var convertLength = _ref.convertLength;

    var value = dropLeadingZero(number) + (unit ? unit : '');
    var converted = undefined;

    if (convertLength !== false && unit in length) {
        converted = transform(number, unit, length);
    }

    if (convertTime !== false && unit in time) {
        converted = transform(number, unit, time);
    }

    if (converted && converted.length < value.length) {
        value = converted;
    }

    return value;
};

module.exports = exports['default'];